import "../lib/serializer.dart";
import "dart:json" as JSON;

class B {
  String bString;
  List<String> bList;
  B(this.bString);
}

class A {
  int aInt;
  String aString;
  B aB;
  Map properties;
  DateTime creationDate = new DateTime.now();
  A(this.aInt, this.aString);
  
}

void main() {
  Encoder encoder = new ReflectionEncoder();
  A object = new A(1, "Text from A class");
  object.properties = {"subfield": 123, "subobject": new A(2, "Text from inner A class")}; 
  object.aB = new B("Text from B class");
  object.aB.bList = ["First item", 2, 3.14, true];
  
  var encodedToMap = encoder.encodeObject(object);
  var json = JSON.stringify(encodedToMap);
  
  print("Map: ${encodedToMap}");
  print("Json: ${objectToJson(object)}");
}
