library serializer_dart;

import "dart:json" as JSON;
import "dart:async";
import "dart:mirrors" as mirrors;

part "encoder.dart";
part "encoders/reflection_encoder.dart";
part "encoders/datetime_encoder.dart";

Encoder _encoder = new ReflectionEncoder();

/**
 * Encode object to json string
 */
String objectToJson(Object object) {
  return JSON.stringify(_encoder.encodeObject(object));
}